'\"
'\" Generated from file 'nmea\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2006-2009, Aaron Faupell <afaupell@users\&.sourceforge\&.net>
'\"
.TH "nmea" n 1\&.1\&.0 tcllib "NMEA protocol implementation"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
nmea \- Process NMEA data
.SH SYNOPSIS
package require \fBTcl 8\&.5 9\fR
.sp
package require \fBnmea ?1\&.1\&.0?\fR
.sp
\fB::nmea::input\fR \fIsentence\fR
.sp
\fB::nmea::open_port\fR \fIport\fR ?speed?
.sp
\fB::nmea::close_port\fR
.sp
\fB::nmea::configure_port\fR \fIsettings\fR
.sp
\fB::nmea::open_file\fR \fIfile\fR ?rate?
.sp
\fB::nmea::close_file\fR
.sp
\fB::nmea::do_line\fR
.sp
\fB::nmea::rate\fR
.sp
\fB::nmea::log\fR ?file?
.sp
\fB::nmea::checksum\fR \fIdata\fR
.sp
\fB::nmea::write\fR \fIsentence\fR \fIdata\fR
.sp
\fB::nmea::event\fR \fIsetence\fR ?command?
.sp
.BE
.SH DESCRIPTION
.PP
This package provides a standard interface for writing software which recieves
NMEA standard input data\&. It allows for reading data from COM ports, files,
or programmatic input\&. It also supports the checksumming and logging of incoming data\&.
After parsing, input is dispatched to user defined handler commands for processing\&.
To define a handler, see the \fBevent\fR command\&. There are no GPS specific functions
in this package\&. NMEA data consists of a sentence type, followed by a list of data\&.
.SH COMMANDS
.TP
\fB::nmea::input\fR \fIsentence\fR
Processes and dispatches the supplied sentence\&. If \fIsentence\fR contains no commas it is treated as a Tcl list, otherwise it must be standard comma delimited NMEA data, with an optional checksum and leading \fB$\fR\&.
.CS


nmea::input {$GPGSA,A,3,04,05,,09,12,,,24,,,,,2\&.5,1\&.3,2\&.1*39}
nmea::input [list GPGSA A 3 04 05  09 12 "" "" 24 "" "" ""  2\&.5 1\&.3 2\&.1]

.CE
.TP
\fB::nmea::open_port\fR \fIport\fR ?speed?
Open the specified COM port and read NMEA sentences when available\&. Port speed is set to
4800bps by default or to \fIspeed\fR\&.
.TP
\fB::nmea::close_port\fR
Close the com port connection if one is open\&.
.TP
\fB::nmea::configure_port\fR \fIsettings\fR
Changes the current port settings\&. \fIsettings\fR has the same format as fconfigure -mode\&.
.TP
\fB::nmea::open_file\fR \fIfile\fR ?rate?
Open file \fIfile\fR and read NMEA sentences, one per line, at the rate specified by ?rate? in milliseconds\&.
The file format may omit the leading \fB$\fR and/or the checksum\&. If rate is <= 0 (the default) then lines
will only be processed when a call to \fBdo_line\fR is made\&.
.TP
\fB::nmea::close_file\fR
Close the open file if one exists\&.
.TP
\fB::nmea::do_line\fR
If there is a currently open file, this command will read and process a single line from it\&.
Returns the number of lines read\&.
.TP
\fB::nmea::rate\fR
Sets the rate at which lines are processed from the open file, in milliseconds\&. The rate remains
consistant across files, there does not need to be a file currently open to use this command\&.
Set to 0 to disable automatic line processing\&.
.TP
\fB::nmea::log\fR ?file?
Starts or stops input logging\&. If a file name is specified then all NMEA data recieved on
the open port will be logged to the ?file? in append mode\&. If file is an empty string then
any logging will be stopped\&. If no file is specified then returns a boolean value indicating
if logging is currently enabled\&. Data written to the port by \fBwrite\fR,
data read from files, or input made using \fBinput\fR, is not logged\&.
.TP
\fB::nmea::checksum\fR \fIdata\fR
Returns the checksum of the supplied data\&.
.TP
\fB::nmea::write\fR \fIsentence\fR \fIdata\fR
If there is a currently open port, this command will write the specified sentence and data to the port
in proper NMEA checksummed format\&.
.TP
\fB::nmea::event\fR \fIsetence\fR ?command?
Registers a handler proc for a given NMEA \fIsentence\fR\&. There may be at most one handler per
sentence, any existing handler is replaced\&.
If no command is specified, returns the name of the current handler for the given \fIsetence\fR
or an empty string if none exists\&. In addition to the incoming sentences there are 2 builtin types,
EOF and DEFAULT\&. The handler for the DEFAULT setence is invoked if there is not a specific handler
for that sentence\&. The EOF handler is invoked when End Of File is reached on the open file or port\&.
.sp
The handler procedures, with the exception of the builtin types,must take exactly one argument,
which is a list of the data values\&.
The DEFAULT handler should have two arguments, the sentence type and the data values\&.
The EOF handler has no arguments\&.
.CS


nmea::event gpgsa parse_sat_detail
nmea::event default handle_unknown

proc parse_sat_detail {data} {
    puts [lindex $data 1]
}

proc handle_unknown {name data} {
    puts "unknown data type $name"
}

.CE
.PP
.SH "BUGS, IDEAS, FEEDBACK"
This document, and the package it describes, will undoubtedly contain
bugs and other problems\&.
Please report such in the category \fInmea\fR of the
\fITcllib Trackers\fR [http://core\&.tcl\&.tk/tcllib/reportlist]\&.
Please also report any ideas for enhancements you may have for either
package and/or documentation\&.
.PP
When proposing code changes, please provide \fIunified diffs\fR,
i\&.e the output of \fBdiff -u\fR\&.
.PP
Note further that \fIattachments\fR are strongly preferred over
inlined patches\&. Attachments can be made by going to the \fBEdit\fR
form of the ticket immediately after its creation, and then using the
left-most button in the secondary navigation bar\&.
.SH KEYWORDS
gps, nmea
.SH CATEGORY
Networking
.SH COPYRIGHT
.nf
Copyright (c) 2006-2009, Aaron Faupell <afaupell@users\&.sourceforge\&.net>

.fi
