'\"
'\" Generated from file 'uevent\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2007-2012 Andreas Kupries <andreas_kupries@users\&.sourceforge\&.net>
'\"
.TH "uevent" n 0\&.3\&.2 tcllib "User events"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
uevent \- User events
.SH SYNOPSIS
package require \fBTcl 8\&.5 9\fR
.sp
package require \fBuevent ?0\&.3\&.2?\fR
.sp
package require \fBlogger\fR
.sp
\fB::uevent::bind\fR \fItag\fR \fIevent\fR \fIcommand\fR
.sp
\fBcommand\fR \fItag\fR \fIevent\fR \fIdetails\fR
.sp
\fB::uevent::unbind\fR \fItoken\fR
.sp
\fB::uevent::generate\fR \fItag\fR \fIevent\fR ?\fIdetails\fR?
.sp
\fB::uevent::list\fR
.sp
\fB::uevent::list\fR \fItag\fR
.sp
\fB::uevent::list\fR \fItag\fR \fIevent\fR
.sp
\fB::uevent::watch::tag::add\fR \fIpattern\fR \fIcommand\fR
.sp
\fB{*}command\fR \fBbound\fR \fItag\fR
.sp
\fB{*}command\fR \fBunbound\fR \fItag\fR
.sp
\fB::uevent::watch::tag::remove\fR \fItoken\fR
.sp
\fB::uevent::watch::event::add\fR \fItag_pattern\fR \fIevent_pattern\fR \fIcommand\fR
.sp
\fB{*}command\fR \fBbound\fR \fItag\fR \fIevent\fR
.sp
\fB{*}command\fR \fBunbound\fR \fItag\fR \fIevent\fR
.sp
\fB::uevent::watch::event::remove\fR \fItoken\fR
.sp
.BE
.SH DESCRIPTION
This package provides a general facility for the handling of user
events\&. Allows the binding of arbitrary commands to arbitrary events
on arbitrary tags, removal of bindings, and event generation\&.
.PP
The main difference to the event system built into the Tcl/Tk core is
that the latter can generate only virtual events, and only for
widgets\&. It is not possible to use the builtin facilities to bind to
events on arbitrary (pseudo-)objects, nor is it able to generate
events for such\&.
.PP
Here we can, by assuming that each object in question is represented
by its own tag\&. Which is possible as we allow arbitrary tags\&.
.PP
More differences:
.IP [1]
The package uses only a two-level hierarchy, tags and events, to
handle everything, whereas the Tcl/Tk system uses three levels, i\&.e\&.
objects, tags, and events, with a n:m relationship between objects and
tags\&.
.IP [2]
This package triggers all bound commands for a tag/event combination,
and they are independent of each other\&. A bound command cannot force
the event processing core to abort the processing of command coming
after it\&.
.PP
.SH API
The package exports eight commands, as specified below\&. Note that when
the package is used from within Tcl 8\&.5+ all the higher commands are
ensembles, i\&.e\&. the :: separators can be replaceed by spaces\&.
.TP
\fB::uevent::bind\fR \fItag\fR \fIevent\fR \fIcommand\fR
Using this command registers the \fIcommand\fR prefix to be triggered
when the \fIevent\fR occurs for the \fItag\fR\&. The result of the
command is an opaque token representing the binding\&. Note that if the
same combination of <\fItag\fR,\fIevent\fR,\fIcommand\fR> is used
multiple times the same token is returned by every call\&.
.sp
The signature of the \fIcommand\fR prefix is
.RS
.TP
\fBcommand\fR \fItag\fR \fIevent\fR \fIdetails\fR
.RE
.sp
where \fIdetails\fR contains the argument(s) of the event\&. Its
contents are event specific and have to be agreed upon between actual
event generator and consumer\&. This package simply transfers the
information and does not perform any processing beyond that\&.
.TP
\fB::uevent::unbind\fR \fItoken\fR
This command releases the event binding represented by the
\fItoken\fR\&. The token has to be the result of a call to
\fB::uevent::bind\fR\&. The result of the command is the empty string\&.
.TP
\fB::uevent::generate\fR \fItag\fR \fIevent\fR ?\fIdetails\fR?
This command generates an \fIevent\fR for the \fItag\fR, triggering
all commands bound to that combination\&. The \fIdetails\fR argument is
simply passed unchanged to all event handlers\&. It is the
responsibility of the code generating and consuming the event to have
an agreement about the format and contents of the information carried
therein\&. The result of the command is the empty string\&.
.sp
Note that all bound commands are triggered, independently of each
other\&. The event handlers cannot assume a specific order\&. They are
also \fInot\fR called synchronously with the invokation of this
command, but simply put into the event queue for processing when the
system returns to the event loop\&.
.sp
Generating an event for an unknown tag, or for a
<\fItag\fR,\fIevent\fR> combination which has no commands bound to it
is allowed, such calls will be ignored\&.
.TP
\fB::uevent::list\fR
In this form the command returns a list containing the names of all
tags which have events with commands bound to them\&.
.TP
\fB::uevent::list\fR \fItag\fR
In this format the command returns a list containing the names of all
events for the \fItag\fR with commands bound to them\&. Specifying an
unknown tag, i\&.e\&. a tag without event and commands, will cause the
command to throw an error\&.
.TP
\fB::uevent::list\fR \fItag\fR \fIevent\fR
In this format the command returns a list containing all commands
bound to the \fIevent\fR for the \fItag\fR\&. Specifying an unknown tag
or unknown event, will cause the command to throw an error\&.
.TP
\fB::uevent::watch::tag::add\fR \fIpattern\fR \fIcommand\fR
This command sets up a sort of reverse events\&. Events generated,
i\&.e\&. the \fIcommand\fR prefix invoked, when observers bind to and
unbind from specific tags\&.
.sp
Note that the command prefix is only invoked twice per tag,
first when the first command is bound to any event of the tag, and
second when the last command bound to the tag is removed\&.
.sp
The signature of the \fIcommand\fR prefix is
.RS
.TP
\fB{*}command\fR \fBbound\fR \fItag\fR
.TP
\fB{*}command\fR \fBunbound\fR \fItag\fR
.RE
.sp
The result of the command is a token representing the watcher\&.
.TP
\fB::uevent::watch::tag::remove\fR \fItoken\fR
This command removes a watcher for (un)bind events on tags\&.
.sp
The result of the command is the empty string\&.
.TP
\fB::uevent::watch::event::add\fR \fItag_pattern\fR \fIevent_pattern\fR \fIcommand\fR
This command sets up a sort of reverse events\&. Events generated,
i\&.e\&. the \fIcommand\fR prefix invoked, when observers bind to and
unbind from specific combinations of tags and events\&.
.sp
Note that the command prefix is only invoked twice per
tag/event combination, first when the first command is bound to it,
and second when the last command bound to the it is removed\&.
.sp
The signature of the \fIcommand\fR prefix is
.RS
.TP
\fB{*}command\fR \fBbound\fR \fItag\fR \fIevent\fR
.TP
\fB{*}command\fR \fBunbound\fR \fItag\fR \fIevent\fR
.RE
.sp
The result of the command is a token representing the watcher\&.
.TP
\fB::uevent::watch::event::remove\fR \fItoken\fR
This command removes a watcher for (un)bind events on tag/event
combinations\&.
.sp
The result of the command is the empty string\&.
.PP
.SH "BUGS, IDEAS, FEEDBACK"
This document, and the package it describes, will undoubtedly contain
bugs and other problems\&.
Please report such in the category \fIuevent\fR of the
\fITcllib Trackers\fR [http://core\&.tcl\&.tk/tcllib/reportlist]\&.
Please also report any ideas for enhancements you may have for either
package and/or documentation\&.
.PP
When proposing code changes, please provide \fIunified diffs\fR,
i\&.e the output of \fBdiff -u\fR\&.
.PP
Note further that \fIattachments\fR are strongly preferred over
inlined patches\&. Attachments can be made by going to the \fBEdit\fR
form of the ticket immediately after its creation, and then using the
left-most button in the secondary navigation bar\&.
.SH "SEE ALSO"
hook(n)
.SH KEYWORDS
bind, event, generate event, hook, unbind
.SH CATEGORY
Programming tools
.SH COPYRIGHT
.nf
Copyright (c) 2007-2012 Andreas Kupries <andreas_kupries@users\&.sourceforge\&.net>

.fi
